/*
-- $Id: SLParse.y,v 1.1 2005/11/08 17:55:25 abel Exp $
--
-- StraightLine Interpreter
--  Parser
-- Practical on compiler design, LMU 2005/6
-- Based on Appels book on "Modern Compiler Implementation"
--
-- For maps could consider:
--   http://java.sun.com/j2se/1.5.0/docs/api/java/util/Map.html
---------------------------------------------------------------------------
*/

package straightparse;


import java_cup.runtime.*;
/* import MJLex.*; */
/* import MJTokens */
/* import MJAbsSyn */

/* Preliminaries to set up and use the scanner.  */
/*
init with {: java_cup.runtime.Scanner.scanner.init();              :};
scan with {: return java_cup.runtime.Scanner.scanner.next_token(); :};
*/

/* Terminals (tokens returned by the scanner). */
terminal String ID;
terminal Integer INT;
terminal PRINT; 
terminal EQ;
terminal PLUS;
terminal MINUS;
terminal TIMES;
terminal DIVIDE;
terminal COMMA;
terminal LPAREN;
terminal RPAREN;
terminal SEMICOLON;
// terminal EOF; // EOF is created automatically

/* Non terminals */
/*
non terminal Factor;
non terminal Term;
*/
non terminal Stm;
non terminal StmList;
non terminal Expr;
non terminal ExprList;
non terminal BinOp;

/* Precedences */
precedence left SEMICOLON;
precedence left EQ;
precedence left PRINT;
precedence left PLUS, MINUS;
precedence left TIMES, DIVIDE;

/* The grammar */

StmList
  ::= Stm
    | StmList SEMICOLON Stm ;

Stm ::= ID EQ Expr
      | PRINT LPAREN ExprList RPAREN ;

/*
Factor 
  ::= ID
    | INT
    | LPAREN Exp RPAREN 
    | LPAREN StmList COMMA Exp RPAREN ;

Term
  ::= Factor
    | Term TIMES Factor
    | Term DIVIDE Factor ;
*/

BinOp ::=
      PLUS
    | MINUS 
    | TIMES
    | DIVIDE 
    ;

Expr ::= Expr BinOp Expr
    | ID
    | INT
    | LPAREN Expr RPAREN 
    | LPAREN StmList COMMA Expr RPAREN 
    ;
   
ExprList ::= Expr
           | ExprList COMMA Expr ;


/* EOF */
